/*
 * I2C slave ver1
 */
 #include <Wire.h>
 #include <TimerOne.h>
 #define pwmRegister OCR1B
 //function prototypes:
 void checkGuideCamera();
 void checkI2C();
 
 const byte cameraOnePin     = 2;
 const byte cameraTwoPin     = 4;
 const byte cameraThreePin   = 6;
 const byte cameraFourPin    = 3;
 const byte rmotorPin        = 10;
 const byte dmotorPin        = 11;
 const byte rdirPin          = 8 ;
 const byte ddirPin          = 12;
 const byte address          = 4 ; 
 byte       dutycycle        = 0;
 byte cameraOneState         = 0;
 byte lastcameraOneState     = 0;
 byte cameraTwoState         = 0;
 byte lastcameraTwoState     = 0;
 byte cameraThreeState       = 0;
 byte lastcameraThreeState   = 0;
 byte cameraFourState        = 0;
 byte lastcameraFourState    = 0;
 volatile byte RmotorPinI2C  = 0;
 volatile byte DmotorPinI2C  = 0;
 volatile byte RdirPinI2C    = 0;
 volatile byte DdirPinI2C    = 0;

 volatile boolean i2cFlag    = false;
 long period                 = 20500;
 long pulseWidth             = 1600;
 int  RESOLUTION  =  1024;
 unsigned long guideCameraMillis;

void setup() {
  Serial.begin(9600);
  pinMode(cameraOnePin,INPUT_PULLUP);
  pinMode(cameraTwoPin,INPUT_PULLUP);
  pinMode(cameraThreePin,INPUT_PULLUP);
  pinMode(cameraFourPin,INPUT_PULLUP);

  pinMode(rmotorPin,OUTPUT);
  pinMode(dmotorPin,OUTPUT);
  pinMode(rdirPin,  OUTPUT);
  pinMode(ddirPin,  OUTPUT);

  Timer1.initialize(period);
  Wire.begin(address);
  Wire.onReceive(receiveEvent);

}

void loop() {
 // read camera inputs and i2c data
 if(millis()- guideCameraMillis > 50)
  {
    guideCameraMillis = millis();
    checkGuideCamera();

    checkI2C();
    
  }
} //                              receiveEvent
//***************************************************************
 void receiveEvent(int howMany)
 {
  if(howMany >= 4)
  { 
    RmotorPinI2C = Wire.read();
    RdirPinI2C   = Wire.read();
    DmotorPinI2C = Wire.read();
    DdirPinI2C   = Wire.read();
    while(Wire.available() > 0)
    {
      Wire.read() ;
    }
   i2cFlag   = true;
  }
 }  //                              checkI2C()
 //************************************************************
 void checkI2C()
 { 
   if(i2cFlag==true)
   {
    noInterrupts();
    analogWrite(rmotorPin,RmotorPinI2C);
    digitalWrite(rdirPin,RdirPinI2C);
    analogWrite (dmotorPin,DmotorPinI2C);
    digitalWrite(ddirPin,DdirPinI2C);
     interrupts ();

     i2cFlag = false ;
   }
 }  //                             checkGuideCamera()
 //***************************************************************
  void checkGuideCamera()
  {
    cameraOneState  = digitalRead(cameraOnePin);
    if(cameraOneState != lastcameraOneState)
    {
      lastcameraOneState = cameraOneState;
      if(cameraOneState == LOW)
      {
        dutycycle = 100;
        Timer1.pwm(rmotorPin,(dutycycle/100)*1023);
        digitalWrite(rdirPin,LOW);
      }
      else
      {
        dutycycle = 0;
        Timer1.pwm(rmotorPin,(dutycycle/100)*1023);
        digitalWrite(rdirPin,LOW);
      }
    }  // end of (one)
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    cameraTwoState = digitalRead(cameraTwoPin);
    if(cameraTwoState != lastcameraTwoState)
    {
      lastcameraTwoState = cameraTwoState ;
      if(cameraTwoState == LOW)
      {
        analogWrite (dmotorPin, 100);
        digitalWrite(ddirPin,  LOW);
      }
      else
      {
        analogWrite (dmotorPin, 0);
        digitalWrite(ddirPin, LOW);
      }
    } // end (Two)
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     cameraThreeState = digitalRead(cameraThreePin) ;
     if(cameraThreeState != lastcameraThreeState)
     {
      lastcameraThreeState = cameraThreeState ;
      if(cameraThreeState == LOW)
       {
        analogWrite (dmotorPin, 100);
        digitalWrite(ddirPin, HIGH );
       }
       else
       {
        analogWrite (dmotorPin, 0 );
        digitalWrite(ddirPin , LOW);
       }
     }  // end if(three)
 //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    cameraFourState = digitalRead(cameraFourPin) ;
    if(cameraFourState != lastcameraFourState)
     {
      lastcameraFourState = cameraFourState ;
      if(cameraFourState == LOW)
       {
        dutycycle = 100 ;
        Timer1.pwm  (rmotorPin, (dutycycle/100)*1023);
        digitalWrite(rdirPin, HIGH ) ;
       }
      else
       {
        dutycycle = 0;
        Timer1.pwm (rmotorPin,(dutycycle/100)*1023);
        digitalWrite(rdirPin, LOW);
       }
     }  // end if(four)
 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
       dutycycle =  100;
       Timer1.pwm(rmotorPin,(dutycycle/100)*1023);
       digitalWrite(rdirPin,LOW); 
       delay(100);
  }    
